<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on May 23, 2008 at 4:39:54 am</time-stamp>
<!-- Changes from: PVAdaptor-Application(Green.11,mkamath)  to: PVAdaptor-Application(Green.12,bbuxton) -->


<methods>
<class-id>PROVISO.UBA.UBAServiceInstance</class-id> <category>private</category>

<body package="PVAdaptor-Application" selector="pruneInvalidInputDescriptors">pruneInvalidInputDescriptors
	
	| invalidKeys |
	invalidKeys := OrderedCollection new.
	inputDescriptors keysAndValuesDo: 
		[:key :descriptor | 
		descriptor isValid 
			ifFalse: [invalidKeys add: key]].
	invalidKeys do: [:eachKey | inputDescriptors removeKey: eachKey]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.UBAServiceInstance</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Application" selector="initInputDescriptorRepository">initInputDescriptorRepository
	
	inputDescriptors := 
		(InputDescriptorRepository 
			recoverFrom: self fileInterface repositoryDirectory , 'inputs.settings'
			identityIndex: (PvrSimpleIdentityIndex on: (PvDictionary new: 8192))
			serializeCallback: 
				[:obj :strm | 
				SmeeAbstractObject 
					write: obj
					onXMLStream: strm]
			materializeCallback: [:strm | SmeeAbstractObject readFromXMLStream: strm]
			skipCallback: [:strm | SmeeAbstractObject skipOnXMLStream: strm])
			cacheSize: Infinity positive;
			yourself.
	self pruneInvalidInputDescriptors.
	^inputDescriptors</body>
</methods>

<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on May 23, 2008 at 4:38:14 am</time-stamp>
<!-- Changes from: PVAdaptor-Schema(Green.24,bbuxton)  to: PVAdaptor-Schema(Green.25,bbuxton) -->


<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>private</category>

<body package="PVAdaptor-Schema" selector="logUnknownSchema:">logUnknownSchema: aName

	self system 
		logWarning: #UNKNOWN_SCHEMA
		messageId: #DC10712
		template: 'Unknown schema: &lt;1s&gt; ignoring: &lt;2s&gt;'
		arguments: (Array with: aName with: self localName)</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>testing</category>

<body package="PVAdaptor-Schema" selector="isValid">isValid

	^schema notNil</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>save/restore</category>

<body package="PVAdaptor-Schema" selector="materializeSchema:">materializeSchema: schemaName 
	
	self schema: 
		(self adaptor inputSchemas 
			detect: [:each | each name = schemaName]
			ifNone: 
				[self ignore: true.
				self logUnknownSchema: schemaName.
				nil])</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputDescriptor</class-id> <selector>resetScheduled</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputDescriptor</class-id> <selector>setStatusUnknownForInputSource:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputDescriptor</class-id> <selector>lastFileTimestamp</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="myInputsSorted:">myInputsSorted: aBlock 
	
	^(SortedCollection new: 256)
		sortBlock: aBlock;
		streamContents: 
			[:sorted | self myInputDescriptorsDo: [:each | sorted nextPut: each]];
		yourself</body>

<body package="PVAdaptor-Schema" selector="myInputDescriptorsDo:">myInputDescriptorsDo: aBlock 
	
	self inputDescriptors do: 
		[:ea | 
		| schema |
		schema := ea schema.
		schema = self 
			ifTrue: [aBlock value: ea]]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>addDescriptorsTo:for:</selector>
</remove-selector>

</st-source>
